--
-- SprayUsagePerKmh
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	v1.0 - 2016-02-16 - Initial implementation
-- 

SprayUsagePerKmh = {};

function SprayUsagePerKmh.prerequisitesPresent(specializations)
    return true;
end;

function SprayUsagePerKmh:load(xmlFile)
	self.getLitersPerSecond = Utils.overwrittenFunction(self.getLitersPerSecond, SprayUsagePerKmh.newGetLitersPerSecond);
	self.getAreEffectsVisible = Utils.overwrittenFunction(self.getAreEffectsVisible, SprayUsagePerKmh.canWeSpray);
	self.getIsReadyToSpray = Utils.overwrittenFunction(self.getIsReadyToSpray, SprayUsagePerKmh.canWeSpray);
end;

function SprayUsagePerKmh:delete()
end;

function SprayUsagePerKmh:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SprayUsagePerKmh:keyEvent(unicode, sym, modifier, isDown)
end;

function SprayUsagePerKmh:update(dt)
end;

function SprayUsagePerKmh:updateTick(dt)
end;

function SprayUsagePerKmh:draw()
end;

function SprayUsagePerKmh:newGetLitersPerSecond(oldFunc, fillType)
	if oldFunc ~= nil then
		local litersPerSecond = oldFunc(self, fillType);
		
		return litersPerSecond * self.lastSpeedReal;
	end;
	
	return 0;
end;

function SprayUsagePerKmh:canWeSpray(oldFunc)
	if oldFunc ~= nil then
		return oldFunc(self) and self.lastSpeedReal > 0;
	end;
	
	return true;
end;